All Classes Namespaces Functions Variables Typedefs Enumerations Enumerator Friends
faiss::IndexSplitVectors Struct Reference

`#include <MetaIndexes.h>`

Inheritance diagram for faiss::IndexSplitVectors:

## Public Member Functions

| IndexSplitVectors (idx_t d, bool threaded=false)
| sum of dimensions seen so far
void | add_sub_index (Index *)
void | sync_with_sub_indexes ()
virtual void | add (idx_t n, const float *x) override
virtual void | search (idx_t n, const float *x, idx_t k, float *distances, idx_t *labels) const override
virtual void | train (idx_t n, const float *x) override
virtual void | reset () override
| removes all elements from the database.
virtual void | set_typename () override
Public Member Functions inherited from faiss::Index
| Index (idx_t d=0, MetricType metric=METRIC_INNER_PRODUCT)
virtual void | add_with_ids (idx_t n, const float *x, const long *xids)
virtual void | range_search (idx_t n, const float *x, float radius, RangeSearchResult *result) const
void | assign (idx_t n, const float *x, idx_t *labels, idx_t k=1)
virtual long | remove_ids (const IDSelector &sel)
virtual void | reconstruct (idx_t key, float *recons) const
virtual void | reconstruct_n (idx_t i0, idx_t ni, float *recons) const
void | compute_residual (const float *x, float *residual, idx_t key) const
void | display () const
virtual std::string | get_typename () const

## Public Attributes

bool | own_fields
bool | threaded
std::vector< Index * > | sub_indexes
idx_t | sum_d
Public Attributes inherited from faiss::Index
std::string | index_typename
int | d
| vector dimension
idx_t | ntotal
| total nb of indexed vectors
bool | verbose
| verbosity level
bool | is_trained
| set if the Index does not require training, or if training is done already
MetricType | metric_type
| type of metric this index uses for search

## Additional Inherited Members

Public Types inherited from faiss::Index
typedef long | idx_t
| all indices are this type

## Detailed Description

splits input vectors in segments and assigns each segment to a sub-index used to distribute a MultiIndexQuantizer

Definition at line 109 of file MetaIndexes.h.

## Member Function Documentation

void faiss::IndexSplitVectors::add | ( | idx_t | n,
|  | const float * | x
| ) |  |

overridevirtual

Add n vectors of dimension d to the index.

Vectors are implicitly assigned labels ntotal .. ntotal + n - 1 This function slices the input vectors in chuncks smaller than blocksize_add and calls add_core.

Parameters

  x | input matrix, size n * d

Implements faiss::Index.

Definition at line 535 of file MetaIndexes.cpp.

void faiss::IndexSplitVectors::search | ( | idx_t | n,
|  | const float * | x,
|  | idx_t | k,
|  | float * | distances,
|  | idx_t * | labels
| ) |  | const

overridevirtual

query n vectors of dimension d to the index.

return at most k vectors. If there are not enough results for a query, the result array is padded with -1s.

Parameters

  x | input vectors to search, size n * d
  labels | output labels of the NNs, size n*k
  distances | output pairwise distances, size n*k

Implements faiss::Index.

Definition at line 580 of file MetaIndexes.cpp.

void faiss::IndexSplitVectors::train | ( | idx_t | n,
|  | const float * | x
| ) |  |

overridevirtual

Perform training on a representative set of vectors

Parameters

  n | nb of training vectors
  x | training vecors, size n * d

Reimplemented from faiss::Index.

Definition at line 635 of file MetaIndexes.cpp.

The documentation for this struct was generated from the following files:

- /data/users/matthijs/github_faiss/faiss/MetaIndexes.h
- /data/users/matthijs/github_faiss/faiss/MetaIndexes.cpp